-- Setting PSVITA at maximum speed
System.setCpuSpeed(444)
System.setBusSpeed(222)
System.setGpuSpeed(222)
System.setGpuXbarSpeed(166)

Sound.init()

local sndOk = Sound.open("app0:/Data/ok.wav")
local sndHit = Sound.open("app0:/Data/hit.wav")
local sndThrow = Sound.open("app0:/Data/throw.wav")
local sndSuccess = Sound.open("app0:/Data/success.wav")

local white = Color.new(255,255,255)
local black = Color.new(0,0,0)
local semiblack = Color.new(0,0,0,100)
local blue = Color.new(93,180,247)

-- Load images
local texGrass = Graphics.loadImage("app0:/Data/grass.png")
local texBg = Graphics.loadImage("app0:/Data/bg.png")
local texTrees = Graphics.loadImage("app0:/Data/trees.png")
local texBeast = Graphics.loadImage("app0:/Data/Monsters/001.png")
local texShadow = Graphics.loadImage("app0:/Data/shadow.png")
local texBall = Graphics.loadImage("app0:/Data/ball.png")

local btnAR = Graphics.loadImage("app0:/Data/ar.png")
local btnList = Graphics.loadImage("app0:/Data/list.png")
local btnBall = Graphics.loadImage("app0:/Data/ballhands.png")
local imgGlow = Graphics.loadImage("app0:/Data/glow.png")

-- Load models
local modCam = Render.loadObject("app0:/cambg.obj", texGrass)
local modGrass = Render.loadObject("app0:/Data/grass.obj", texGrass)
local modSky = Render.loadObject("app0:/Data/sky.obj", texBg)
local modTrees = Render.loadObject("app0:/Data/trees.obj", texTrees)
local modBeast = Render.loadObject("app0:/Data/Monsters/001.obj", texBeast)
local modShadow = Render.loadObject("app0:/Data/shadow.obj", texShadow)
local modBall = Render.loadObject("app0:/Data/ball.obj", texBall)

-- Set texture filters
Graphics.setImageFilters(texGrass, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texBg, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texTrees, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texBeast, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texShadow, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texBall, FILTER_LINEAR, FILTER_LINEAR)

oldpad = SCE_CTRL_CROSS

-- Initializing outer camera at 640x480@45fps 
Camera.init(OUTER_CAM, VGA_RES, 45)
Camera.setSharpness(400)
Camera.setSaturation(3.4)

Controls.enableAccel()
Controls.enableGyro()

local frot = 0.0

local delayTouch = 0.0
local useCamera = false

local firstStart = true
local animType = 0

local camRotX = 0.0
local camRotY = 0.0
local camRotZ = 0.0
local beastName = "Wolfie"
local enemyRevRot = false
local enemyRot = 0.0

local capturing = 0.0
local checkcapure = false
local captured = 0

local ballrot = 0
local shootDelay = 0.0
local balls = {}

function shoot(x, y, z, angle, button, speed)
	if button == 1 then
		--spawn ball
		table.insert(balls, {x = x, y = y, z = z, dx = bulletDx, dz = bulletDy, angle = angle, speed = speed})
	end
end

function LoadMonster(num)
Render.unloadModel(modBeast)
Graphics.freeImage(texBeast)
	if num == 1 or num == 0 then
		beastName = "Wolfie"
		animType=0
		texBeast = Graphics.loadImage("app0:/Data/Monsters/001.png")
		modBeast = Render.loadObject("app0:/Data/Monsters/001.obj", texBeast)
	end
	if num == 2 then
		beastName = "Alienus"
		animType=0
		texBeast = Graphics.loadImage("app0:/Data/Monsters/002.png")
		modBeast = Render.loadObject("app0:/Data/Monsters/002.obj", texBeast)
	end
	if num == 3 then
		beastName = "Ghostu"
		animType=1
		texBeast = Graphics.loadImage("app0:/Data/Monsters/003.png")
		modBeast = Render.loadObject("app0:/Data/Monsters/003.obj", texBeast)
	end
Graphics.setImageFilters(texBeast, FILTER_LINEAR, FILTER_LINEAR)
end

-- Main loop
while true do
	
	local x1,y1 = Controls.readTouch()
	local ax, ay, az = Controls.readAccel()
	local gx, gy, gz = Controls.readGyro()

	if checkcapure==true then
		if capturing>0 and captured<3 then 
			if frot>0 then
				frot = frot - 4
			end
		
			capturing = capturing - 0.1
			if capturing > 13 and capturing <14  then 
				frot=15
			end
			if capturing > 8 and capturing <9 then 
				frot=15
			end
			if capturing > 4 and capturing <5 then 
				frot=15
			end
			
			shootDelay=5
		else
			captured = math.ceil(math.random(0,5))
			if captured >=3 then
				Sound.play(sndSuccess, NO_LOOP)
			end
			
			capturing=0
			checkcapure=false
		end
	end
	
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	else
	-- check for touch
		if x1 ~= nil then
			-- AR Button
			if x1>880 and y1<75 then
				delayTouch = 3
				if useCamera == true then
					useCamera = false
				else
					useCamera = true
				end
			end
			-- Monster List
			if x1<75 and y1<75 then
				delayTouch = 3
				dofile("app0:/list.lua")
			end

			-- Throw ball
			if x1>300 and x1<660 and y1>350 then
				if shootDelay==0 and captured<3 and firstStart==false then
					shootDelay=5
					ballrot=0
					Sound.play(sndThrow, NO_LOOP)
					shoot(0, 0+(camRotX*1.4), 0, camRotY, 1, 0.3)
				end
			end
		end
	end
	
	if gx> 0.05 then
		camRotX = camRotX + (gx/20) 
	elseif gx<-0.05 then
		camRotX = camRotX + (gx/20) 
	end

	if camRotX> 1 then 
		camRotX=1
	end
	if camRotX<-1 then 
		camRotX=-1
	end
	if gy> 0.05 then
		camRotY = camRotY + (gy/25) 
	elseif gy<-0.05 then
		camRotY = camRotY + (gy/25) 
	end
	
	if camRotY >= 6.2831853072 then 
		camRotY=0
	end
	if camRotY<0 then 
		camRotY=6.283185
	end
	
	--camRotZ = -ax
	
	-- Blend camera scene
	Graphics.initBlend()
	Screen.clear(blue)
	
	-- Getting current camera output
	scene = Camera.getOutput()
	Render.setCamera(0, 0, 0, camRotX, camRotY, camRotZ)
		
	Graphics.setImageFilters(scene, FILTER_LINEAR, FILTER_LINEAR)

	-- render camera
	if useCamera == true then
		--Graphics.drawScaleImage(0, -90, scene, 1.5, 1.5)
		Render.useTexture(modCam, scene) 
		Render.drawModel(modCam, 0, 0, 0, 0, 0, 0, true)
	else
		Render.drawModel(modSky, 0, -2, 0, 0, 0, 0)
		Render.drawModel(modGrass, 0, -2, 0, 0, 0, 0)
		Render.drawModel(modTrees, 0, -2, 0, 0, 0, 0)
	end
	
	-- beast animation
	if enemyRevRot==true then 
		enemyRot = enemyRot + 0.4
		else
		enemyRot = enemyRot - 0.4
	end
	if enemyRot >2 then 
		enemyRevRot=false
		elseif enemyRot <-8 then 
		enemyRevRot=true
	end
	if capturing > 16.5  then 
		Graphics.drawScaleImage(0, 0, imgGlow, 2, 2)
	end
	if capturing==0 and captured<3 then
		if animType==0 then
			Render.drawModel(modBeast, 0, -2, -7, enemyRot, 0, 0)
		end
		if animType==1 then
			Render.drawModel(modBeast, 0, enemyRot/10, -7, enemyRot/4, 0, 0)
		end
		Render.drawModel(modShadow, 0, -2, -7, 0, 0, 0)
	else
		Render.drawModel(modBall,  0, -1.8, -7, 0, 0, -frot)
		if captured >= 3 then
		Graphics.debugPrint(440, 220, "Gotcha!", white)
		Graphics.debugPrint(370, 244, beastName .. " was caught!", white)
		Graphics.debugPrint(350, 520, "Press START to try again", white)
		end
		
	end
	
	--update ball positions
	for i,v in ipairs(balls) do
	
	local ballangle = v.angle
	v.x = v.x - (v.speed * math.sin(ballangle))
	v.z = v.z - (v.speed * math.cos(ballangle))
	if v.y > -1.5 then
		v.y = v.y -0.04
		else
		v.y = -1.5
	end
	
	if v.speed>0 then
		v.speed = v.speed -0.005
		else
		table.remove(balls,i)
	end
	ballrot = ballrot + 15
	Render.drawModel(modBall, v.x, v.y, v.z, -ballrot, math.deg(camRotY) , 0)
	-- ball collisions

		--hit monster
		if v.x>-1 and v.x<1 and v.z>-9 and v.z<-6 then
			capturing=17
			checkcapure=true
			Sound.play(sndHit, NO_LOOP)
			table.remove(balls,i)
		end
	end	
		
	if shootDelay>0 then
		shootDelay = shootDelay - 0.1
	else
		if captured<3 then
			Graphics.drawImage(403, 405-(enemyRot*3), btnBall)
		end
		shootDelay=0
	end
	Graphics.drawImage(20, 16, btnList)
	Graphics.drawImage(900, 16, btnAR)
	
	if firstStart==true then
		Graphics.fillRect(0, 960, 0, 544, black)
		Graphics.debugPrint(360, 244, "Press Triangle to calibrate", white)
	end
	
	
	Graphics.termBlend()
	
	-- Check for input
	pad = Controls.read()
	-- Reset sensors
	if Controls.check(Controls.read(), SCE_CTRL_TRIANGLE) then
		if shootDelay==0 then
			shootDelay=3
			camRotX = 0
			camRotY = 0
			camRotZ = 0
			Sound.play(sndOk, NO_LOOP)
			firstStart=false
		end
	end
	if Controls.check(Controls.read(), SCE_CTRL_CROSS) then
		if shootDelay==0 and captured<3 and firstStart==false then
			shootDelay=5
			ballrot=0
			Sound.play(sndThrow, NO_LOOP)
			shoot(0, 0+(camRotX*1.4), 0, camRotY, 1, 0.3)
		end
	end
	
	if Controls.check(Controls.read(), SCE_CTRL_UP) then
		frot = frot + 5
		useCamera = true
	elseif Controls.check(Controls.read(), SCE_CTRL_DOWN) then
		frot = frot - 5
		useCamera = false
	end
	
	-- Restart
	if Controls.check(Controls.read(), SCE_CTRL_START) then
		if captured>=3 and firstStart==false then
		LoadMonster(math.ceil(math.random(0, 3)))
		camRotX = 0
		camRotY = 0
		camRotZ = 0
		capturing = 0.0
		checkcapure = false
		captured = 0
		shootDelay=0
		firstStart=true
		end
	end
	-- Flip screen
	Screen.flip()
	oldpad = pad
end
