-- Init audio device
Sound.init()
-- Init some colors
local white = Color.new(255, 255, 255)
local black = Color.new(0, 0, 0)
local red = Color.new(255, 0, 0)
local transp = Color.new(255, 255, 255,0)

local oldpad = SCE_CTRL_CROSS


local texBg = Graphics.loadImage("app0:/Data/listbg.png")
local texBeastb = Graphics.loadImage("app0:/Data/Monsters/001.png")
local modBeastb = Render.loadObject("app0:/Data/Monsters/001.obj", texBeastb)
local modBg = Render.loadObject("app0:/cambg.obj", texBg)

Graphics.setImageFilters(texBg, FILTER_LINEAR, FILTER_LINEAR)
-- List a directory
local monsters = {"Wolfie", "Alienus", "Ghostu"}--System.listDirectory("app0:/Data/Monsters/")

local btnBack = Graphics.loadImage("app0:/Data/back.png")

-- Init a index
local i = 1
local delayTouch = 8.0
local enemyRot = 0.0

function LoadMonsterList(num)
Render.unloadModel(modBeastb)
Graphics.freeImage(texBeastb)
	if num == 1 or num == 0 then
		texBeastb = Graphics.loadImage("app0:/Data/Monsters/001.png")
		modBeastb = Render.loadObject("app0:/Data/Monsters/001.obj", texBeastb)
	end
	if num == 2 then
		texBeastb = Graphics.loadImage("app0:/Data/Monsters/002.png")
		modBeastb = Render.loadObject("app0:/Data/Monsters/002.obj", texBeastb)
	end
	if num == 3 then
		texBeastb = Graphics.loadImage("app0:/Data/Monsters/003.png")
		modBeastb = Render.loadObject("app0:/Data/Monsters/003.obj", texBeastb)
	end
Graphics.setImageFilters(texBeastb, FILTER_LINEAR, FILTER_LINEAR)
end

-- Main loop
while true do
	local x1,y1 = Controls.readTouch()
	
	if x1 ~= nil then
		-- Back button
		if x1>870 and y1>460 then
			Graphics.freeImage(btnBack)
			break
		end
	end
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	end
	enemyRot = enemyRot - 0.2
	
	Graphics.initBlend()
	Screen.clear(transp)

	Render.drawModel(modBg, 0, 0, 0, 0, 0, 0, true)
		
	local y = 80
	-- Write visible menu entries
	for j, file in pairs(monsters) do
		x = 12
		if j >= i and y < 960 then
			if i == j then
				color = red
			else
				color = white
			end
			Graphics.debugPrint(x, y, string.format("%02d",j) .. ". " .. monsters[j], color)
			y = y + 32
		end
	end
	
	--Font.print(fnt, 726, 34, "teset", white)
	
	if #monsters>0 then
	Graphics.debugPrint(12, 4, "Monster " .. i .. "/" .. #monsters, white)
	end
	
	Graphics.debugPrint(320, 522, "Vitamon GO v0.1 by VitaHEX - www.patreon.com/vitahex", white)
	Graphics.drawImage(882, 473, btnBack)

	
	Render.setCamera(0, 0, 0, 0, 0, 0)
	Render.drawModel(modBeastb, 1.5, -1, -6, 0, enemyRot, 0)
	
	Graphics.termBlend()
	
	-- Check for input
	pad = Controls.read()
	if Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) then
		if #monsters>0 then
			-- select with X
		end
	elseif Controls.check(pad, SCE_CTRL_UP) and not Controls.check(oldpad, SCE_CTRL_UP) then
		if #monsters>0 then
		i = i - 1
		if i < 1 then
			i = #monsters
		end
		end
		LoadMonsterList(i)
	elseif Controls.check(pad, SCE_CTRL_DOWN) and not Controls.check(oldpad, SCE_CTRL_DOWN) then
		if #monsters>0 then
		i = i + 1
		if i > #monsters then
			i = 1
		end
		end
		LoadMonsterList(i)
	end
	
	-- Check for out of bounds in menu
	if i > #monsters then
		i = 1
	elseif i < 1 then
		i = #monsters
	end
	
	-- Update oldpad and flip screen
	oldpad = pad
	Screen.flip()
	
end
